﻿@using Portal.Models;
@using System.Web.UI.WebControls;
@using DevExpress.Web.Mvc;
@using DevExpress.Web.Mvc.UI;
@using DevExpress.Utils;
@model Toyota.Common.Web.MVC.ModelHolder
@{     
    Layout = "~/Views/Layout/Dashboard.cshtml";
}


<script src="@Url.Content("~/Scripts/jquery.mtz.monthpicker.js")" type="text/javascript"></script>

@section Style{
    .ui-datepicker.ui-corner-all { -moz-border-radius: 4px; -webkit-border-radius: 4px; border-radius: 4px; }
    .iu-widget-header { background-color: #94B6E8; color: #94B6E8; }
    .ui-widget-header {
        background: url("images/ui-bg_highlight-soft_15_cc0000_1x100.png") repeat-x scroll 50% 50% #94B6E8;
        background-color: #DDECFF;
        border: 1px solid #94B6E8;
        color: #94B6E8;
        @*font-weight: bold;*@
    }
    div.ui-datepicker {width: 17em; padding: .2em .2em 0;}
    div.ui-datepicker-header.mtz-monthpicker {border: 1px solid #DDECFF; background-color: #DDECFF; color: #DDECFF; font-weight: bold;}
    table.mtz-monthpicker {width: 100%; font-size: .9em; border-collapse: collapse; margin:0 0 .4em; }
    td.ui-state-default.mtz-monthpicker-month {border: 1px solid #fff;}
    td.ui-state-default.mtz-monthpicker-month {text-align: center; cursor: pointer; padding: 5px;}
    td.ui-state-default.mtz-monthpicker-month:hover, td.ui-state-default.mtz-monthpicker-month-selected {background: none; background-color: #DDECFF; color: #fff; cursor: pointer;}
    td.ui-state-default.mtz-monthpicker-month:hover {background-color: #fff; color: #000;}
    select.mtz-monthpicker-year {margin-top: 7px; border:1px solid #6A8CCB;}
}


@section Script{
    $(document).ready(function() {
        
 
        $('#PO_MONTH_I').monthpicker({
            startYear: new Date().getFullYear() - 4,
            finalYear: new Date().getFullYear() + 4,
            pattern: 'mmm yyyy',
                monthNames: ['January', 'February', 'March', 'April', 'May', 'June', 'July', 'August', 'September', 'October', 'November', 'December']
        });

        $('#PRMonth_I').bind('onchange',function(e){
            alert("input change");
        });  
    });
}

@section StartupScript{
    PO_MONTH.value = '';
}

<style type="text/css">
    #PO_MONTH_I, #PO_MONTH
    {
        background-color:#F6CECE!important;    
    }
    
    #PO_NUMBER_I, #PO_NUMBER,#gridPartnerRefView_I,#gridPartnerRefView,#PR_NUMBER_I,#PR_NUMBER,#PO_STATUS_I,#PO_STATUS
    {
        background-color:#F5F6CE!important;    
    }


</style>

<script type="text/javascript">


    $(document).ready(function () { 
        GridPO_STATUS.SetHeight(-73);
        GridgridPartnerRefView.SetHeight(-149);
        $('#infCreate').hide();

        $('#PO_NUMBER_I').keypress(function(e){
            if(e.keyCode==8 || e.keyCode == 46 || e.keyCode == 37 || e.keyCode == 38 || e.keyCode == 39 || e.keyCode == 40)
            {
            }
            else if(String.fromCharCode(e.which).match(/[^A-Za-z0-9]/))
            {
                e.preventDefault();
            }
        });

        $('#PR_NUMBER_I').keypress(function(e){
            if(e.keyCode==8 || e.keyCode == 46 || e.keyCode == 37 || e.keyCode == 38 || e.keyCode == 39 || e.keyCode == 40)
            {
            }
            else if(String.fromCharCode(e.which).match(/[^A-Za-z0-9]/))
            {
                e.preventDefault();
            }
        });

    });


    function DoSearch(s, e) {
        var sq = PO_MONTH.GetText();
        var a = PO_NUMBER.GetText();
        var b = PR_NUMBER.GetText();
        var err = 0;

        if(a.match(/[^A-Za-z0-9]/) != null){
            err = 1;
        }
        if(b.match(/[^A-Za-z0-9]/) != null){
            err = 1;
        }

        
        if (sq == "") {
            //MessageBox('Please select production month!','warning_icon.png','Warning',280);
            $.msgBox({ title: "Warning", type: "alert", content: "Please select production month!"});
        } else {
            if(err == 1){
                $.msgBox({ title: "Warning", type: "alert", content: "Only can be use number or text!"});
                }else{
                gridpocreation.PerformCallback();
                disabledButton();
                }
                err = 0;
        }
    }

//    function convertDate (param){
//        var param;

//        if (param == null){
//            yearmonthval = "";

//        }else{

//            var PRMonthVal = param.toLocaleString();
//            //var d = new Date(PRMonth.GetValue());
//            var d = new Date(PRMonthVal);
//            var curr_month = d.getMonth() + 1 ;
//            var curr_year = d.getFullYear();
//            var n = String(curr_month).length;

//            if (n==1){
//                curr_month = '0'+curr_month;
//            }else{
//                curr_month= curr_month;
//            }

//            var yearmonthval = curr_year+''+curr_month;
//        }

//        return yearmonthval;
//    }

    function GetProductionMonth(productionMonth) {
         var paramStr = String(productionMonth).replace('-', '');
         var paramStrLength = String(paramStr).length;

         var year = String(paramStr).substring(paramStrLength, paramStrLength - 4);
         var month = String(paramStr).substring(0, paramStrLength - 5);
         var monthEnum = {
             January: '01',
             February: '02',
             March: '03',
             April: '04',
             May: '05',
             June: '06',
             July: '07',
             August: '08',
             September: '09',
             October: '10',
             November: '11',
             December: '12'
         };
         var monthNum = "";
         if (Boolean(month))
             monthNum = monthEnum[month];
          
         return year + monthNum;
     }


    function SetActivationButton(s, e) {
        var criteria = PR_NUMBER.GetText() + PO_NUMBER.GetText() + PO_STATUS.GetText() + PO_MONTH.GetText()+gridPartnerRefView.GetText();
        btnSearch.SetEnabled(criteria.length > 0);
        btnClear.SetEnabled(criteria.length > 0);
    
        var cnt=gridpocreation.GetPageCount();
              //btnDownload.SetEnabled(cnt>0);
    }

    function enabledButton() {
        btnCreate.SetEnabled(true);
        btnDownload.SetEnabled(true);
        btnSearch.SetEnabled(true);
        btnClear.SetEnabled(true);
    }

    function disabledButton() {
        btnCreate.SetEnabled(false);
        btnDownload.SetEnabled(false);
        btnSearch.SetEnabled(false);
        btnClear.SetEnabled(false);
    }

    function DoClearGrid() {
        enabledButton();
        gridpocreation.ClearFilter();
        PR_NUMBER.SetText("");
        PO_NUMBER.SetText("");
        PO_STATUS.SetText("");
        gridPartnerRefView.SetText("");        
        PO_MONTH.SetText("");
        PO_MONTH.SetValue();        
        
        //SetActivationButton();

    }

    function OnBeginCallbackGrid(s, e) {
        e.customArgs["pPR_NUMBER"] = PR_NUMBER.GetText();
        e.customArgs["pPO_NUMBER"] = PO_NUMBER.GetText();
        e.customArgs["pSTATUS"] = PO_STATUS.GetValue();
        e.customArgs["pPO_MONTH"] = GetProductionMonth(PO_MONTH.GetValue());
        e.customArgs["pLP_CD"] = gridPartnerRefView.GetText();
        enabledButton();
    }

    function OnEndCallbackGrid(s, e) {
     enabledButton();
    }


    function MessageBox(s, e) {
        if (e != '') {
            msgboxicon.src = '/Content/Images/' + e;
        } else {

            msgboxicon.src = '/Content/Images/warning_icon.png';
        }
        msgboxcaption.SetText(s);
        msgbox.Show();
    }

    //Download Excel------------------------------------------------------------------------------------------
    var IsDownload = "no";

    function DoDownload(s, e) {
        var a = PO_NUMBER.GetText();
        var b = PR_NUMBER.GetText();
        var err = 0;

        if(a.match(/[^A-Za-z0-9]/) != null){
            err = 1;
        }
        if(b.match(/[^A-Za-z0-9]/) != null){
            err = 1;
        }

        if(PO_MONTH.GetText()=="")
        {
             //MessageBox('Please select PO Month', '');
             $.msgBox({ title: "Warning", type: "alert", content: "Please select production month!", afterClose : enabledButton});
             disabledButton();     
        }
        else
        {
            if(err == 1){
                $.msgBox({ title: "Warning", type: "alert", content: "Only can be use number or text!"});
                }else{

                                if (gridpocreation.GetPageCount()>0){
                                    IsDownload = "yes";   
                                    disabledButton();
                                    BeginCallbackDownload(s, e);
                                }else{
                                     //MessageBox('No data for download, make sure data displayed on grid  !!!', '');
                                     $.msgBox({ title: "Warning", type: "alert", content: "No data for download, make sure data displayed on grid!", afterClose : enabledButton});
                                     disabledButton();
                                }
                }
                err = 0;
        }        
    }

    function BeginCallbackDownload(s, e) {
        if(PO_MONTH.GetText()=="")
        {         
           //MessageBox('Please select PO Month', '');
           $.msgBox({ title: "Warning", type: "alert", content: "Please select PO Month", afterClose : enabledButton});
           disabledButton();
        }
         else
         {
          $.ajax(
            {
                type: "POST",
                url: "@Url.Content("~/D31202/exportToExcel")",
                data:
                    {               
                        pPR_NUMBER : PR_NUMBER.GetText(),
                        pPO_NUMBER : PO_NUMBER.GetText(),
                        pPO_STATUS : PO_STATUS.GetValue(),
                        pPO_MONTH  : PO_MONTH.GetText(),
                        pLP_CD     : gridPartnerRefView.GetText()             
                    },
                success: function (result) {
                    var link = "@Url.Content("~/")"+result.excelLink;
                    window.location = link;
                    enabledButton();

                },
                error: function (result) {
                    //MessageBox('Error Download Data:' + result.toString, '');
                    var message = 'Error Download Data:' + result.toString;
                    $.msgBox({ title: "Warning", type: "alert", content: message, afterClose : enabledButton});
                    disabledButton();
                }
            });
            }
        }
    //AKHIr Download Excel------------------------------------------------------------------------------------------
    var MESSAGE;
    function checkProgressCreatePO(){

        
        var SEQ = 0;
        console.log("MESSAGE : "+MESSAGE);

        if(MESSAGE == 'PO creation has been finished' || MESSAGE == 'Create PO failed with current PR, PR not in released status or PO was created' || MESSAGE == 'Logistic Partner Code not found in Trucking Scheme' || MESSAGE == 'Price Not Found' || MESSAGE == 'PO cannot create with this production month' || MESSAGE == 'Several PO successfully created,but several PR failed to create PO.' || MESSAGE == 'You are not authorized to perform this action.')
        {
            
            //SEQ = 1;
            MESSAGE = "";
            
        }
        else
        {

            $.ajax({
                type: "POST",
                url: "@Url.Content("~/D31202/checkProgressCreatePO")",
                data: {},
                    success: function (result) {
                        //
                        var resValue = result.split('|');
                        console.log('RES : '+resValue[1]);
                        if (resValue[0] == 'Success'){

                            if (resValue[1] == 'PO creation has been finished'){
                                $('#progressCreatePO').html(resValue[1]);
                                $('#infCreate').delay(6000).hide("slow");
                                DoSearch();
                                $.msgBox({ title: "info", type: "info", content: resValue[1], afterClose : enabledButton });
                                MESSAGE = resValue[1];
                                DoSearch();

                            }
                            else if(resValue[1] == 'Create PO failed with current PR, PR not in released status or PO was created'){
                                $('#infCreate').hide();
                                $.msgBox({ title: "Warning", type: "alert", content: resValue[1], afterClose : enabledButton });
                                MESSAGE = resValue[1];
                            }
                            else if(resValue[1] == 'Logistic Partner Code not found in Trucking Scheme'){
                                $('#infCreate').hide();
                                $.msgBox({ title: "Warning", type: "alert", content: resValue[1], afterClose : enabledButton });
                                MESSAGE = resValue[1];
                            }
                            else if(resValue[1] == 'Price Not Found'){
                                $('#infCreate').hide();
                                $.msgBox({ title: "Warning", type: "alert", content: resValue[1], afterClose : enabledButton });
                                MESSAGE = resValue[1];
                            }
                            else if(resValue[1] == 'PO cannot create with this production month'){
                                $('#infCreate').hide();
                                $.msgBox({ title: "Warning", type: "alert", content: resValue[1], afterClose : enabledButton });
                                MESSAGE = resValue[1];
                            }
                            else if(resValue[1] == 'Several PO successfully created,but several PR failed to create PO.'){
                                $('#infCreate').hide();
                                $.msgBox({ title: "Warning", type: "alert", content: resValue[1], afterClose : enabledButton });
                                MESSAGE = resValue[1];
                                DoSearch();
                            }
                            else if(resValue[1] == 'You are not authorized to perform this action.'){
                                $('#infCreate').hide();
                                $.msgBox({ title: "Warning", type: "alert", content: resValue[1], afterClose : enabledButton });
                                MESSAGE = resValue[1];
                                DoSearch();
                            }
                            else{
                                $('#infCreate').show();
                                $('#progressCreatePO').html(resValue[1]);
                                MESSAGE = resValue[1];
                                
                            }
                        }else{
                            $('#infCreate').hide();
                            MESSAGE = resValue[1];
                            
                        }
                    },
                    error: function (result) {
                         $('#infCreate').hide();
                        MESSAGE = resValue[1];
                        
                    }
            });
            //SEQ++;
            setTimeout("checkProgressCreatePO()",1000);
            

        }
            

    }


    function DoCreate(s, e) {
        if(PO_MONTH.GetText()=="")
        {
             //MessageBox('Please select PO Month', '');
             $.msgBox({ title: "Warning", type: "alert", content: "Please select PO Month", afterClose : enabledButton }); 
             disabledButton();    
        }
        else if(gridpocreation.GetSelectedKeysOnPage() == ""){
             //MessageBox('No data selected','warning_icon.png','Warning',210);
             $.msgBox({ title: "Warning", type: "alert", content: "No data selected", afterClose : enabledButton }); 
             disabledButton(); 
        }
        else
        {
                var selectCount = gridpocreation.GetSelectedRowCount();
                var valGrid = JSON.stringify(gridpocreation.GetSelectedKeysOnPage());
                valGrid = valGrid.replace('["','');
                valGrid = valGrid.replace('"]',';');
                valGrid = valGrid.replace(/","/g,';');
                if (selectCount==0) {
                    //MessageBox('No data selected!','warning_icon.png','Warning',210);
                    $.msgBox({ title: "Warning", content: "No data selected!", afterClose : enabledButton });
                    disabledButton();
                } else {
                    
                    var prno = valGrid;
                    performCreatePO(prno);

                }

        }
        

    }      
    
    function performCreatePO (prno){
        $.ajax({
                        type: "POST",
                        url: "@Url.Content("~/D31202/performCreate")",
                        data: {
                            PR_NO : prno,
                            PROD_MONTH : GetProductionMonth(PO_MONTH.GetValue())               
                        },
                        success: function (result) {
                            var resValue = result.split('|');
                            if (resValue[0] == 'Sucess'){
                                //MessageBox(resValue[1],'info_icon.png','Information',230);
                                checkProgressCreatePO();
                                //$.msgBox({ title: "info", type: "info", content: resValue[1], afterClose : enabledButton }); 
                                gridpocreation.ClearFilter();
                                gridpocreation.UnselectAllRowsOnPage();
                                //enabledButton();
                            }else
                            {
                                //MessageBox(resValue[1],'error_icon.png','Error',220);
                                $.msgBox({ title: "error", type: "error", content: resValue[1], afterClose : enabledButton }); 
                                gridpocreation.ClearFilter();
                                gridpocreation.UnselectAllRowsOnPage();
                                //enabledButton();
                            }
                        },
                        error: function (result) {
                            var resValue = result.split('|');
                            //MessageBox(resValue[1],'error_icon.png','Error',220);
                            $.msgBox({ title: "error", type: "error", content: resValue[1], afterClose : enabledButton });
                            gridpocreation.ClearFilter();
                            gridpocreation.UnselectAllRowsOnPage();
                           //enabledButton();
                        }
                    });
    }   

    //-----------------------DETAIL PO---------------------------------
    function OnPOClick(s, e) {
    if (s != '&nbsp;') {
            PO_NO_DET.SetText(s);
            gridmonPopupPODetail.ClearFilter();
            monPopupPO.SetHeaderText('Purchase Order Detail');
            monPopupPO.Show();
            BeginCallbackPOHead(s, e);
    } else {
           popupInformation.Show();
        }
    }
    
    function OnPOBackClick(s, e) {        
        monPopupPO.Hide();
    }

    function BeginCallbackPOHead(s, e) {

        PO_DATE_DET.SetText("");
        PO_LP_DET.SetText("");
        PO_STATUS_DET.SetText("");
        PO_CURR_DET.SetText("");
              
          $.ajax(
            {
                type: "POST",
                url: "@Url.Content("~/D31202/PopupDetailPOHeader")",
                data:
                {
               
                    PO_NO : s
                         
              },
             success: function (result) {

                $.each(result, function (index, item) {
                    if (item) {
                        PO_DATE_DET.SetText(item.CREATED_DT);
                        PO_LP_DET.SetText(item.LOG_PARTNER_NAME);
                        PO_STATUS_DET.SetText(item.PO_STATUS_FLAG);
                        PO_CURR_DET.SetText(item.PO_CURR);
                    }
                });                                      
            },
            error: function (result) {
                //alert("Data not exist");
                $.msgBox({ title: "Warning", type: "alert", content: "Data not exist", afterClose : enabledButton });
            }
        });
    }

    function OnBeginCallbackGridPODetail(s, e) {
        e.customArgs["pPO_NO_DET"] = PO_NO_DET.GetText();
    }
    //-----------------------DETAIL PO---------------------------------

    //-----------------------DETAIL PR---------------------------------
    function OnPRClick(s, e) {
    if (s != '') {
          PR_NO_DET.SetText(s);
            gridmonPopupPRDetail.ClearFilter();
            monPopupPR.SetHeaderText('Purchase Requisition Detail');
            monPopupPR.Show();
            BeginCallbackPRHead(s, e);
    } else {
           popupInformation.Show();
        }
    }
    
    function OnPRBackClick(s, e) {        
        monPopupPR.Hide();
    }

    function BeginCallbackPRHead(s, e) {

        PR_DATE_DET.SetText("");
        PR_LP_DET.SetText("");
        PR_STATUS_DET.SetText("");
              
          $.ajax(
            {
                type: "POST",
                url: "@Url.Content("~/D31202/PopupDetailPRHeader")",
                data:
                {
               
                    PR_NO : s
                         
              },
             success: function (result) {

                $.each(result, function (index, item) {
                    if (item) {
                        PR_DATE_DET.SetText(item.CREATED_DT);
                        PR_LP_DET.SetText(item.LOG_PARTNER_NAME);
                        PR_STATUS_DET.SetText(item.PR_STATUS_FLAG);
                    }
                });                                      
            },
            error: function (result) {
                //alert("Data not exist");
                $.msgBox({ title: "Warning", type: "alert", content: "Data not exist", afterClose : enabledButton });
            }
        });
    }

    function OnBeginCallbackGridPRDetail(s, e) {
        e.customArgs["pPR_NO_DET"] = PR_NO_DET.GetText();
    }
    //-----------------------DETAIL PR---------------------------------


    //---------------------------------------------------------------------------------------------------------


</script>
<div style="display: table; border: 1px solid #002D96; background-color: #DEECFD;
    padding: 10px; width:690px; margin-right:0px;">
  @Html.Action("SectionHead", "D31202")   

</div>

@* div spacing *@
<div style="height: 10px;">
@* div spacing *@
</div>


<div style="display: table; width:1309px">
    @Html.Action("SectionGrid", "D31202")
</div>

@Html.Action("MessageBox", "D31202")

@Html.DevExpress().PopupControl(settings =>
        {
            settings.Name = "monPopupPO";
            settings.Width = System.Web.UI.WebControls.Unit.Pixel(650);
            settings.Height = System.Web.UI.WebControls.Unit.Pixel(585);
            settings.ScrollBars = ScrollBars.Vertical;
            //settings.Width = System.Web.UI.WebControls.Unit.Percentage(40);
            //settings.Height = System.Web.UI.WebControls.Unit.Percentage(100);
            settings.Modal = true;
            settings.ShowCloseButton = false;
            settings.Top = 35;
            settings.CloseAction = CloseAction.CloseButton;
            settings.PopupHorizontalAlign = PopupHorizontalAlign.WindowCenter;
            //settings.PopupVerticalAlign = PopupVerticalAlign.WindowCenter;
            //settings.DragElement = DragElement.Window;
            //settings.ShowHeader = false;
            settings.SetContent(() =>
            {
                Html.RenderPartial("monPopupPO");
            });
        }).GetHtml()



 @Html.DevExpress().PopupControl(settings =>
        {
            settings.Name = "monPopupPR";
            settings.ScrollBars = ScrollBars.Vertical;
            settings.Width = System.Web.UI.WebControls.Unit.Pixel(580);
            //settings.Width = System.Web.UI.WebControls.Unit.Percentage(40);
            settings.Height = System.Web.UI.WebControls.Unit.Pixel(566);
            settings.Modal = true;
            settings.ShowCloseButton = false;
            settings.Top = 35;
            settings.CloseAction = CloseAction.CloseButton;
            settings.PopupHorizontalAlign = PopupHorizontalAlign.WindowCenter;
            //settings.PopupVerticalAlign = PopupVerticalAlign.WindowCenter;
            //settings.DragElement = DragElement.Window;
            //settings.ShowHeader = false;
            settings.SetContent(() =>
            {
                Html.RenderPartial("monPopupPR");
            });
        }).GetHtml()